_IOControlAccessMode = function () {
  this.any = 0;
  this.read = 1;
  this.write = 2;
  this.readWrite = 3;
}
exports.IOControlAccessMode = new _IOControlAccessMode();

_IOControlBufferingMethod = function () {
  this.buffered = 0;
  this.directInput = 1;
  this.directOutput = 2;
  this.neither = 3;
}
exports.IOControlBufferingMethod = new _IOControlBufferingMethod();

_DeviceAccessMode = function () {
  this.read = 0;
  this.write = 1;
  this.readWrite = 2;
}
exports.DeviceAccessMode = new _DeviceAccessMode();

_DeviceSharingMode = function () {
  this.shared = 0;
  this.exclusive = 1;
}
exports.DeviceSharingMode = new _DeviceSharingMode();

KnownDeviceTypes = (function () {
  var cls = function KnownDeviceTypes() {
  };
  

  cls.unknown = new Number();
  return cls;
}) ();
exports.KnownDeviceTypes = KnownDeviceTypes;

IIOControlCode = (function () {
  var cls = function IIOControlCode() {
    this.accessMode = new IOControlAccessMode();
    this.bufferingMethod = new IOControlBufferingMethod();
    this.controlCode = new Number();
    this.deviceType = new Number();
    this.function = new Number();
  };
  

  return cls;
}) ();
exports.IIOControlCode = IIOControlCode;

IOControlCode = (function () {
  var cls = function IOControlCode() {
    this.accessMode = new IOControlAccessMode();
    this.bufferingMethod = new IOControlBufferingMethod();
    this.controlCode = new Number();
    this.deviceType = new Number();
    this.function = new Number();
  };
  
var cls = function IOControlCode(deviceType, function, accessMode, bufferingMethod) {
      this.accessMode = new IOControlAccessMode();
      this.bufferingMethod = new IOControlBufferingMethod();
      this.controlCode = new Number();
      this.deviceType = new Number();
      this.function = new Number();
};


  return cls;
}) ();
exports.IOControlCode = IOControlCode;

CustomDevice = (function () {
  var cls = function CustomDevice() {
    this.inputStream = new Object();
    this.outputStream = new Object();
  };
  

  cls.prototype.sendIOControlAsync = function sendIOControlAsync(ioControlCode, inputBuffer, outputBuffer, callback) {
    /// <signature>
    /// <summary>Function summary.</summary>
    /// <param name="ioControlCode" type="IIOControlCode">A param.</param>
    /// <param name="inputBuffer" type="Object">A param.</param>
    /// <param name="outputBuffer" type="Object">A param.</param>
    /// </signature>
  }


  cls.prototype.trySendIOControlAsync = function trySendIOControlAsync(ioControlCode, inputBuffer, outputBuffer, callback) {
    /// <signature>
    /// <summary>Function summary.</summary>
    /// <param name="ioControlCode" type="IIOControlCode">A param.</param>
    /// <param name="inputBuffer" type="Object">A param.</param>
    /// <param name="outputBuffer" type="Object">A param.</param>
    /// </signature>
  }


  cls.fromIdAsync = function fromIdAsync(deviceId, desiredAccess, sharingMode, callback) {
    /// <signature>
    /// <summary>Function summary.</summary>
    /// <param name="deviceId" type="String">A param.</param>
    /// <param name="desiredAccess" type="DeviceAccessMode">A param.</param>
    /// <param name="sharingMode" type="DeviceSharingMode">A param.</param>
    /// </signature>
  }



  cls.getDeviceSelector = function getDeviceSelector(classGuid) {
    /// <signature>
    /// <summary>Function summary.</summary>
    /// <param name="classGuid" type="String">A param.</param>
    /// <returns type="String" />
    /// </signature>
    return new String();
  }


  return cls;
}) ();
exports.CustomDevice = CustomDevice;

